<template>
  <section id="userManagement">
    <v-layout>
      <AlertBox ref="alertBox" />
      <v-flex class="text-center">
        <blockquote class="blockquote">
          <v-data-table
            :loading="loading"
            loading-text="กำลังโหลดข้อมูล... กรุณารอสักครู่"
            :headers="headers"
            :items="userListTable"
            :items-per-page="10"
            item-key="id"
            class="elevation-1">
            <template v-slot:top>
              <editProfilePopup @updateProfile="getAllUser" ref="dialogBox" />
            </template>
            <template v-slot:item.action="{ item }">
              <v-icon small @click="editItem(item)" > mdi-square-edit-outline </v-icon>
            </template>
          </v-data-table>
        </blockquote>
      </v-flex>
    </v-layout>
  </section>
</template>

<script>
  import AlertBox from '~/components/general/alert-box/AlertBox'
  import editProfilePopup from "~/components/user-management/editProfilePopup";
  export default {
    name: 'user-management',
    components: {
      AlertBox,
      editProfilePopup
    },
    data () {
      return {
        loading: true,
        dialog: false,
        headers: [
          { text: 'ลำดับที่', align: 'left', value: 'no' },
          { text: 'ชื่อผู้ใช้', align: 'left', value: 'fullName' },
          { text: 'อายุ', align: 'left', value: 'age' },
          { text: 'เบอร์โทรศัพท์', align: 'left', value: 'tel' },
          { text: 'ที่อยู่', align: 'left', value: 'address' },
          { text: 'แก้ไขข้อมูลผู้ใช้', align: 'left', value: 'action', sortable: false }
        ],
        userList: [],
        userListTable: [],
        updateTrackingData: {
          id: '',
          tracking_number: ''
        }
      }
    },
    mounted () {
      this.getAllUser()
    },
    watch: {
      dialog (val) {
        val || this.close()
      }
    },
    methods: {
      showAlert: function (value) {
        const vm = this
        const alert = {
          'mainTitle': value.title,
          'subTitle': value.text,
          'type': value.type,
          'time': value.time,
          'autoClose': value.autoClose,
          'show': value.show
        }
        vm.$refs.alertBox.showBox(alert)
      },
      editItem (item) {
        const vm = this
        const userData = vm.userList.find(e => e.id === item.id)
        vm.$refs.dialogBox.dialog = true
        vm.$refs.dialogBox.getProfiles(userData)
      },
      getAllUser () {
        const vm = this
        vm.loading = true
        vm.$axios.$get('/user/all-user')
          .then((res) => {
            vm.userListTable = []
            vm.userList = res.data
            vm.userList.map((value, index) => {
              const userForTable = {
                no: index+1,
                id: value.id,
                fullName: `${value.firstname} ${value.lastname}`,
                age: value.age,
                tel: value.tel,
                address: value.address
              }
              vm.userListTable.push(userForTable)
            })
          })
          .catch((e) => {
            if (e.response) {
              vm.showAlert({title: 'ผิดพลาด!', text: e.response.data.messages, type: 'error', time: 5, autoClose: true, show: true})
            }
          })
          .finally(() => {
            vm.loading = false
          })
      }
    }
  }
</script>
